<?php

namespace App\Http\Controllers;
use Illuminate\Session\TokenMismatchException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class Source extends Controller {    
    public function createNew(Request $r) {
        if ($r->ftype == 'file') {
            $fl = fopen(DEFAULT_PATH . '/' . $r->path . '/' . $r->fname, 'wb');
            fclose($fl);
        } else {
            mkdir(DEFAULT_PATH . '/' . $r->path . '/' . $r->fname);
        }
        echo json_encode(array('status' => 'success', 'message' => 'Sccessfully created'));
    }
	public function downloadFile($path){
		
			$filePath = DEFAULT_PATH .$path;
			if (file_exists($filePath)) {
				header('Content-Description: File Transfer');
				header('Content-Type: application/octet-stream');
				header('Content-Disposition: attachment; filename="' . basename($filePath) . '"');
				header('Expires: 0');
				header('Cache-Control: must-revalidate');
				header('Pragma: public');
				header('Content-Length: ' . filesize($filePath));
				readfile($filePath);
			} else {
				echo json_encode(['status'=>0,'message'=>'File is not exist']);
			}
		}
    public function renameFile(Request $r) {
        $destpath = DEFAULT_PATH . '/' . $r->newpath;
        $sorcpath = DEFAULT_PATH . '/' . $r->oldpath;
        if (!file_exists($destpath) || !is_dir($destpath)) {
            if (rename($sorcpath, $destpath)) {
                echo json_encode(array('status' => 'success', 'message' => 'Successfully renamed'));
            } else {
                echo json_encode(array('status' => 'faild', 'message' => 'Error wile rename this file'));
            }
        } else {
            echo json_encode(array('status' => 'faild', 'message' => 'Error wile rename this file'));
        }
    }

    public function getListOfFolders($fullpath, $fileFolderList, $mydir) {
        $rtnstr = '';
        foreach ($fileFolderList as $fileFolder) {
            if ($fileFolder != '' && is_dir($fullpath . '/' . $fileFolder)) {
                $rtnstr .= '<li><a class="context-menu path-link" href="javascript:void(0)" data-value="folder" source-path="' . $mydir . $fileFolder . '"><i class="fa fa-folder"></i>' . $fileFolder . '</a></li>';
            }
        }
        return $rtnstr;
    }

    public function getListOfFiles($fullpath, $fileFolderList, $mydir) {
        $rtnstr = '';
        foreach ($fileFolderList as $fileFolder) {
            if ($fileFolder != '' && !is_dir($fullpath . '/' . $fileFolder)) {
                $rtnstr .= '<li><a class="context-menu path-link" href="javascript:void(0)"  data-value="file" source-path="' . $mydir . $fileFolder . '"><i class="fa fa-file-o"></i>' . $fileFolder . '</a></li>';
            }
        }
        return $rtnstr;
    }

    public function deleteAll($dir) {
        foreach (glob($dir . '/*') as $file) {
            if (is_dir($file)) {
                $this->deleteAll($file);
            } else {
                unlink($file);
            }
        }
        rmdir($dir);
    }

    public function delete($dir) {
        unlink($dir);
    }

    public function deleteFile(Request $r) {
        extract($_POST);
        if ($r->filetype == 'file') {
            $this->delete(DEFAULT_PATH . '/' . $r->sourcePath);
            echo json_encode(array('status' => 'success', 'message' => 'Successfully deleted!..'));
        } else if ($r->filetype == 'folder') {
            $this->deleteAll(DEFAULT_PATH . '/' . $r->sourcePath);
            echo json_encode(array('status' => 'success', 'message' => 'Successfully deleted!..'));
        }
    }

    public function copyFolder($src, $dst) {
        $result = false;
        // open the source directory
        $dir = opendir($src);
        // Make the destination directory if not exist
        @mkdir($dst);
        // Loop through the files in source directory
        while ($file = readdir($dir)) {
            if (( $file != '.' ) && ( $file != '..' )) {
                if (is_dir($src . '/' . $file)) {
                    // Recursively calling custom copy function
                    // for sub directory 
                    $this->copyFolder($src . '/' . $file, $dst . '/' . $file);
                } else {
                    $result = copy($src . '/' . $file, $dst . '/' . $file);
                }
            }
        }
        closedir($dir);
        return $result;
    }

    public function copyFile(Request $r) {
        $source_path = DEFAULT_PATH . '/' . $r->source;
        $dest_path = DEFAULT_PATH . '/' . $r->destination . '/' . $r->filename;
        $dest_folder = DEFAULT_PATH . '/' . $r->destination;
        $dest_path = str_replace('//', '/', $dest_path);
        $ext = pathinfo($r->filename, PATHINFO_EXTENSION);
        $result = false;
        if (!file_exists($dest_path) && $ext != '') {
            if (!is_dir($dest_folder)) {
                mkdir($dest_folder);
                $result = copy($source_path, $dest_path);
            } else {
                $result = copy($source_path, $dest_path);
            }
            if ($result) {
                echo json_encode(array('status' => 'success', 'message' => 'Successfully Copied!..'));
            } else {
                echo json_encode(array('status' => 'faild', 'message' => 'Error while file is copying'));
            }
        } else if (!is_dir($dest_path) && $ext == '') {
            $result = $this->copyFolder($source_path, $dest_path);
            if ($result) {
                echo json_encode(array('status' => 'success', 'message' => 'Successfully Copied!..'));
            } else {
                echo json_encode(array('status' => 'faild', 'message' => 'Error while file is copying'));
            }
        } else {
            if ($ext != '') {
				$newfile=str_replace('.php','_copy.php',$r->filename);
				$dest_path = DEFAULT_PATH . '/' . $r->destination . '/' . $newfile;
				$result = copy($source_path, $dest_path);
                echo json_encode(array('status' => 'success', 'message' => 'Successfully Copied!..'));               
            } else if ($ext == '') {
                $msg = 'This folder is already exist';
				 echo json_encode(array('status' => 'faild', 'message' => $msg));
            }
           
        }
    }

    public function listFolderFiles($dir = '') {
        if ($dir == '') {
            $fullpath = DEFAULT_PATH;
            $mydir = '';
        } else {
            $fullpath = DEFAULT_PATH . '/' . $dir;
            $mydir = $dir . '/';
        }
        try {
            $fileFolderList = array_values(array_diff(scandir($fullpath), array('..', '.')));
            $rtnstr = '';
            if (count($fileFolderList) > 0) {
                $rtnstr .= '<ul>';
                $rtnstr .= $this->getListOfFolders($fullpath, $fileFolderList, $mydir);
                $rtnstr .= $this->getListOfFiles($fullpath, $fileFolderList, $mydir);
                $rtnstr .= '</ul>';
            }
            return $rtnstr;
        } catch (\Exception $e) {
            die($e->getMessage());
        }
    }
	public function add2FileModifiedList($source_file_path){
		date_default_timezone_set("Asia/Kolkata");
		$arrayData =include app_path('Helpers/arrayData.php');		
		$user_id =session('user_id');
		$user_name =session('user_name');
		$user_email =session('user_email');	
		$path_array[$source_file_path]=date('d-m-Y h:i:s A');
		if(!isset($arrayData[$user_email])){
			$arrayData[$user_email]=$path_array;
		}else{
			$arrayData[$user_email][$source_file_path]=date('d-m-Y h:i:s A');
		}				
		$str='<?php'.PHP_EOL;
		$str.='$users= ['.PHP_EOL;
		foreach($arrayData as $user_email_key=>$user_array){
			$str.="\t'".$user_email_key."'=>[".PHP_EOL;
			foreach($user_array as $path_key=>$date_str){
				$str.="\t\t'".$path_key."'=>'".$date_str."',".PHP_EOL;
			}
			$str.="\t],".PHP_EOL;
		}
		$str.='];'.PHP_EOL;
		$str.='return $users;';
		$filePath=UPDATED_FILE_STORAGE_PATH;		
		$fileHandle = fopen($filePath, 'w');
		if ($fileHandle) {
			// Write the content to the file
			fwrite($fileHandle, $str);
			// Close the file
			fclose($fileHandle);
		}
	}
	
    public function editFile(Request $r) {
		$user_email=session('user_email');
		if(isset($user_email)){
			$cpath = $r->path;
			$source_file_path=DEFAULT_PATH . $cpath;		
			$this->add2FileModifiedList($source_file_path);
			$file_list['source_file_path'] = $source_file_path;
			$file_list['file_path'] = $cpath;
			echo view('source', $file_list);
		}else{			
			return redirect(url('/'))->with('error', 'Session expired. Please login.');
		}
        
    }

    public function getFileList(Request $r) {
        //extract($_GET);
        $list = '';
        $content = '';
        $fullpath = DEFAULT_PATH . '/' . $r->source_path;
        $dir = $r->source_path;
        if (is_dir($fullpath)) {
            $list = $this->listFolderFiles($dir);
        } else {
            $content = file_get_contents($dir);
        }
        echo json_encode(array('list' => $list, 'content' => $content));
    }

    public function saveFileContent(Request $r) {
		try {
			$fullpath = DEFAULT_PATH . '/' . $r->source_file_path;
			if (!file_exists($fullpath)) {
				mkdir($fullpath);
			}
			$file_handle = fopen($fullpath, 'w');
			fwrite($file_handle, $r->content);
			fclose($file_handle);
			echo json_encode(array('status' => 1, 'message'=>'success'));
		} catch (TokenMismatchException $e) {
			echo  json_encode(['status' =>0, 'message'=>'session expired','url'=>url('/')]);
		}
		
    }

}