$(function () {
    $.contextMenu({
        selector: '.context-menu',
        build: function (clickedElement) {
            //var dataValue=clickedElement[0].dataset.value;//javascript
            var dataValue = $(clickedElement).attr('data-value');
            var sourcePath = $(clickedElement).attr('source-path');

            $('.active').each(function () {
                $(this).removeClass('active');
            });
            $(clickedElement).addClass('active');
            menuItems = {
                move: {name: 'Move', icon: 'fa-arrows'},
				download: {name: 'Download', icon: 'fa-download'},
                copy: {name: 'Copy', icon: 'copy'},
                rename: {name: 'Rename', icon: 'fa-file-text-o'},
                delete: {name: 'Delete', icon: 'delete'},
                compress: {name: 'Compress', icon: 'fa-file-archive-o'},
                passwordprotect: {name: 'Password Protect', icon: 'fa-lock'}
            };
            if (dataValue === 'folder') {
                // dynamically add the items
                var open = {name: 'Open', icon: 'fa-folder-open-o'};
                var addnew = {name: 'Add New', icon: 'fa-plus-square-o'};
                menuItems = {open, addnew, ...menuItems};
            } else if (dataValue === 'file') {
                var edit = {name: 'Edit', icon: 'edit'}
                menuItems = {edit, ...menuItems};
            }
            return {
                callback: function (key, opt) {
                    var element = opt.$trigger;// getting triggerd element in call back function
                    if (key === 'open') {
                        openFolder(element);
                    } else if (key === 'edit') {
                        openFile(element);
                    } else if (key === 'copy') {
                        copyFile(element);
                    } else if (key === 'delete') {
                        deleteFile(sourcePath, element, dataValue);
                    } else if (key === 'rename') {
                        renameFile(element);
                    } else if (key === 'move') {
                        moveFiles(element);
                    } else if (key === 'addnew') {
                        addNew(element);
                    }else if(key=='download'){
						downloadFile(element);
					}
                },
                items: menuItems
            };
        }
    });
});

$(window).bind('keydown', function (e) {
    if (event.ctrlKey || e.metaKey) {
        switch (String.fromCharCode(e.which).toLowerCase()) {
            case 's':
                e.preventDefault();
                saveContent();
                break;
        }
    }
});
var base_url = $('base').attr('href');
$(document).ready(function () {
    $(document).on('click', '.path-link', function (e) {
        e.preventDefault();
        e.stopPropagation();
        $('.active').each(function () {
            $(this).removeClass('active');
        });
        $(this).addClass('active');
        var element = $(this);
        folderCollapse(element);
    });
    $(document).on('dblclick', '.path-link', function (e) {
        e.preventDefault();
        e.stopPropagation();
        var element = $(this);
        $('.active').each(function () {
            $(this).removeClass('active');
        });
        $(element).addClass('active');
        var ftype = $(this).attr('data-value');
        if (ftype == 'folder') {
            openFolder(element);
        } else if (ftype === 'file') {
            openFile(element);

        }
    });

});
function addNew(element) {
    var finfo = getFileInfo(element);
    $.confirm({
        title: 'Add New',
        boxWidth: '500px',
        type: 'blue',
        useBootstrap: false,
        backgroundDismiss: false,
        backgroundDismissAnimation: 'glow',
        content: '' +
                '<form action="" class="formName">' +
                '<div class="form-group">' +
                '<label><b>' + finfo.spath + '</b></label><br>' +
                '<input type="radio" value="folder" name="addtype" class="addtype" value="folder"/> <label>Folder</label> ' +
                '<input type="radio" value="file" name="addtype" class="addtype" value="file" checked/> <label>File</label>' +
                '<br><label id="addnewlabel">Enter New File Name</label>' +
                '<input autocomplete="off" type="text" id="addnewpath" class="form-control" required />' +
                '</div>' +
                '</form>',
        buttons: {
            rename: {
                text: 'Create',
                btnClass: 'btn-dark',
                action: function () {
                    //$(this.$$cancel).attr('disabled', 'true');
                    //$(this.$$rename).text('Please wait..');
                    //$(this.$content).find('#addnewpath').attr('disabled', 'true');
                    var fname = this.$content.find('#addnewpath').val();
                    var ftype = 'file';
                    this.$content.find('.addtype').each(function () {
                        if ($(this).prop('checked') === true) {
                            ftype = $(this).val();
                        }
                    });

                    var specialChar = /[`!@#$%^&*()+=\[\]{};':"\\|,<>\/?~]/;
                    if (fname === '' || specialChar.test(fname)) {
                        $.alert('Invalid!. Name could not be empty or any the following characters ' + specialChar);
                        return false;
                    } else {
                        $.ajax({
                            type: 'post',

                            url: base_url + '/source/createNew',
                            data: {
                                _token: $('input[name="_token"]').val(),
                                path: finfo.spath,
                                fname: fname,
                                ftype: ftype,
                                fpath: finfo.fpath
                            },
                            async: false,
                            success: function (response) {
                                //responseAlert(response);
                                var info = $.parseJSON(response);
                                if (info.status === 'success') {
                                    openFolder(element);
                                } else {
                                    $.alert(info.message);
                                }
                                // console.log($(element));

                            },
                            complete: function () {
                            }
                        });
                    }

                }
            },
            cancel: {
                text: 'Cancel',
                btnClass: 'btn-default',
                action: function () {
                    //close
                }
            }
        }
    });
}
function moveFiles(element) {
    var finfo = getFileInfo(element);
    $.confirm({
        title: 'Move',
        boxWidth: '500px',
        type: 'blue',
        useBootstrap: false,
        backgroundDismiss: false,
        backgroundDismissAnimation: 'glow',
        content: '' +
                '<form action="" class="formName">' +
                '<div class="form-group">' +
                '<label><b>' + finfo.spath + '</b></label><br>' +
                '<label>Move to</label>' +
                '<input autocomplete="off" type="text" placeholder="Enter path to move" id="move-path" class="form-control" value="' + finfo.spath + '" required />' +
                '</div>' +
                '</form>',
        buttons: {
            rename: {
                text: 'Move',
                btnClass: 'btn-dark',
                action: function () {
                    $(this.$$cancel).remove();
                    $(this.$$rename).text('Please wait..');
                    $(this.$content).find('#move-path').attr('disabled', 'true');
                    var movename = this.$content.find('#move-path').val();
                    var specialChar = /[`!@#$%^&*()+=\[\]{};':"\\|,<>?~]/;
                    if (movename === '' || specialChar.test(movename)) {
                        $.alert('Invalid!. Path does not contain any following characters ' + specialChar);
                        return false;
                    } else {
                        $.ajax({
                            type: 'post',

                            url: base_url + '/source/renameFile',
                            data: {
                                _token: $('input[name="_token"]').val(),
                                oldpath: finfo.spath,
                                newpath: movename
                                        //filename: fileName
                            },
                            async: false,
                            success: function (response) {
                                //responseAlert(response);
                                var info = $.parseJSON(response);
                                if (info.status === 'success') {
                                    $(element).remove();
                                } else {
                                    $.alert(info.message);
                                }
                                // console.log($(element));

                            },
                            complete: function () {
                            }
                        });
                    }

                }
            },
            cancel: {
                text: 'Cancel',
                btnClass: 'btn-default',
                action: function () {
                    //close
                }
            }
        }
    });
}
function downloadFile(element){
	 var source = $(element).attr('source-path');
    //source=source.replace('/','%2F');
    window.open(base_url + '/downloadFile/' + source);
}
function renameFile(element) {
    var finfo = getFileInfo(element);
    var oldName = finfo.fname;
    $.confirm({
        title: 'Rename',
        boxWidth: '500px',
        type: 'blue',
        useBootstrap: false,
        draggable: false,
        backgroundDismiss: false,
        backgroundDismissAnimation: 'glow',
        content: '' +
                '<form action="" class="formName">' +
                '<div class="form-group">' +
                '<label><b>' + finfo.spath + '</b></label><br>' +
                '<label>Enter New name</label>' +
                '<input autocomplete="off" type="text" placeholder="Give a name to rename" id="rename-path" class="form-control" value="' + oldName + '" required />' +
                '</div>' +
                '</form>',
        buttons: {
            rename: {
                text: 'Rename',
                btnClass: 'btn-dark',
                action: function () {
                    $(this.$$cancel).remove();
                    $(this.$$rename).text('Please wait..');
                    $(this.$content).find('#rename-path').attr('disabled', 'true');
                    var rename = this.$content.find('#rename-path').val();
                    var renamePath = finfo.fpath + '/' + rename;
                    //var spstr = '`!@#$%^&*()+=\[\]{};\':"\\|,<>\/?~';
                    var specialChar = /[`!@#$%^&*()+=\[\]{};':"\\|,<>\/?~]/;
                    if (rename === '' || specialChar.test(rename)) {
                        $.alert('Invalid!. Name does not contain ' + specialChar);
                        return false;
                    } else {
                        $.ajax({
                            type: 'post',

                            url: base_url + '/source/renameFile',
                            data: {
                                _token: $('input[name="_token"]').val(),
                                oldpath: finfo.spath,
                                newpath: renamePath
                                        //filename: fileName
                            },
                            async: false,
                            success: function (response) {
                                //responseAlert(response);
                                var info = $.parseJSON(response);
                                if (info.status === 'success') {
                                    $(element).attr('source-path', renamePath);
                                    $(element).contents().filter(function () {
                                        return this.nodeType === 3;
                                    }).replaceWith(rename);
                                    var parent = $(element).parent('li').parent('ul').prev('a');
                                    //console.log(parent);
                                    if (parent.length == 0) {
                                        window.location = window.location.href;
                                    } else {
                                        openFolder(parent);
                                    }

                                    //$(element).text(rename);
                                } else {
                                    $.alert(info.message);
                                }
                                // console.log($(element));

                            },
                            complete: function () {
                            }
                        });
                    }

                }
            },
            cancel: {
                text: 'Cancel',
                btnClass: 'btn-default',
                action: function () {
                    //close
                }
            }
        }
    });

}
function responseAlert(st = 0, response) {
    var info = $.parseJSON(response);
    if (info.status === 'success' && st === 1) {
        $.alert(info.message);
    } else {
        $.alert(info.message);
}
}
function deleteFile(sourcePath, element, dataValue) {
    $.confirm({
        title: 'Delete Warning',
        boxWidth: '500px',
        type: 'blue',
        useBootstrap: false,
        backgroundDismiss: false,
        backgroundDismissAnimation: 'glow',
        content: '<b style="color:red;">' + sourcePath + '</b><br> <b style="color:green">Do you want to delete this?</b>',
        buttons: {
            btnyes: {
                text: 'Yes',
                btnClass: 'btn-dark',
                action: function () {
                    $.ajax({
                        type: 'post',

                        url: base_url + '/source/deleteFile',
                        async: false,
                        data: {
                            _token: $('input[name="_token"]').val(),
                            sourcePath: sourcePath,
                            filetype: dataValue
                        },
                        success: function (response) {
                            var info = $.parseJSON(response);
                            if (info.status == 'success') {
                                var ulpnt = $(element).parents('ul li').length;
                                if (ulpnt == 1) {
                                    $(element).parents('ul').remove();
                                } else {
                                    $(element).parent('li').remove();
                                }
                            }
                        }

                    });
                }
            },
            btnno: {
                text: 'No',
                action: function () { }
            }
        }
    });
}
function pasteToClipboard() {
    var psteData = '';
    return psteData;
}
function getFileInfo(element) {
    var sourcePath = $(element).attr('source-path');
    var destarr = sourcePath.split('/');
    //var fileName = destarr[destarr.length - 1];
    var fileName = $(element).text().trim();
    destarr.splice(-1, 1);
    var destinationPath = destarr.join('/');
    return {spath: sourcePath, fname: fileName, fpath: destinationPath};
}
function copyFile(element) {
    var sourcePath = $(element).attr('source-path');
    var destarr = sourcePath.split('/');
    var fileName = destarr[destarr.length - 1];
    destarr.splice(-1, 1);
    var destinationPath = destarr.join('/');
    $.confirm({
        title: 'Copy',
        boxWidth: '500px',
        type: 'blue',
        useBootstrap: false,
        draggable: false,
        backgroundDismiss: false,
        backgroundDismissAnimation: 'glow',
        content: '' +
                '<form action="" class="formName">' +
                '<div class="form-group">' +
                '<label>File Path:<br></label>' +
                '<label>/' + sourcePath + fileName + '</label><br>' +
                '<label><br>Copy to</label>' +
                '<input type="text" placeholder="Enter file path to copy" id="dest-path" class="form-control" value="/' + destinationPath + '" required />' +
                '</div>' +
                '</form>',
        buttons: {
            copy: {
                text: 'Copy',
                btnClass: 'btn-dark',
                action: function () {
                    $(this.$$cancel).remove();
                    $(this.$$copy).text('Please wait..');
                    $(this.$content).find('#dest-path').attr('disabled', 'true');
                    var destpath = this.$content.find('#dest-path').val();
                    if (destpath === '' && destpath === '/') {
                        $.alert('Path is empty. Please enter a path to copy the file.');
                        return false;
                    }
                    $.ajax({
                        type: 'post',

                        url: base_url + '/source/copyFile',
                        data: {
                            _token: $('input[name="_token"]').val(),
                            source: sourcePath,
                            destination: destpath,
                            filename: fileName
                        },
                        async: false,
                        success: function (response) {
                            var info = $.parseJSON(response);
                            if (info.status === 'success') {
                                getListFolder(destpath);
                                //$.alert(info.message);
                            } else {
                                $.alert(info.message);
                                //getListFolder(destpath);
                            }
                        },
                        complete: function () {
                        }
                    });
                }
            },
            cancel: {
                text: 'Cancel',
                btnClass: 'btn-default',
                action: function () {
                    //close
                }
            }
        }
    });

}
function folderCollapse(element) {
    var ftype = $(element).attr('data-value');
    if (ftype === 'folder') {
        if ($(element).parent('li').find('ul').length > 0) {
            $(element).parent('li').find('ul').remove();
        }
    }
}
function reloadFolder(element) {
    var parent = $(element).parents('ul').prev('a').length;
    if (parent > 0) {
        var newElement = $(element).parents('ul').prev('a');
        //console.log(newElement);
        openFolder(newElement);
    }

}
function openFolder(element) {
    $(element).find('i').addClass('fa-circle-o-notch fa-spin');
    $(element).find('i.fa-spin').removeClass('fa-folder');
    $(element).parent('li').find('ul').remove();

    var source = $(element).attr('source-path');
    var list = '';
    var info = getListFolder(source);
    list = info.list;
    setTimeout(function () {
        if (list !== '') {
            $(element).parent('li').append(list);
        } else {
            $.dialog({
                title: 'Alert',
                content: 'This folder is empty now!..',
                backgroundDismiss: false,
                backgroundDismissAnimation: 'glow'
            });
        }
        $(element).find('.fa-spin').addClass('fa-folder');
        $(element).find('.fa-folder').removeClass('fa-circle-o-notch fa-spin');
    }, 150, element);

}
function openFile(element) {
    var source = $(element).attr('source-path');
    //source=source.replace('/','%2F');
    window.open(base_url + '/source/file/' + source);
}
function getListFolder(source) {
    var result;
    $.ajax({
        type: 'get',
        url: base_url + '/source/getFileList',
        data: {
            source_path: source
        },
        async: false,
        success: function (response) {
            result = $.parseJSON(response);
        }
    });
    return result;
}

function saveContent() {
    var content = editor.getValue();
    var source_file_path = $('.source_file_path').val();
    $(".fa-save").addClass('fa-circle-o-notch fa-spin');
    $(".fa-spin").removeClass('fa-save');
    $.ajax({
        type: 'post',
        url: base_url + '/source/saveFileContent',
        data: {
            _token: $('input[name="_token"]').val(),
            content: content,
            source_file_path: source_file_path
        },
        success: function (response) {
            var info = jQuery.parseJSON(response);
            setTimeout(function () {
                if (info.status === 1) {
                    $(".fa-spin").addClass('fa-save');
                    $(".fa-save").removeClass('fa-circle-o-notch fa-spin');
                }else if(info.status ===0){
                    window.location=info.url;
                } else {
                    alert(info.status);
                }
            }, 200, info);
        }, error: function (x, t, m) {
            if (t === "timeout") {
                $(".fa-save").css({color: 'red'});
                alert("File not saved. Because Server is not connected!..");
            } else {
                //	alert(t);
            }
        }
    });
}

function fullScreen() {
    editor.setSize("100%", "96vh");
}
function getSelectedRange() {
    return {from: editor.getCursor(true), to: editor.getCursor(false)};
}

function autoFormatSelection() {
    var range = getSelectedRange();
    if (range.from === range.to) {
        CodeMirror.commands["selectAll"](editor);
        range = getSelectedRange();
    }
    editor.autoFormatRange(range.from, range.to);
}

function commentSelection(isComment) {
    var range = getSelectedRange();
    editor.commentRange(isComment, range.from, range.to);
}