<?php
namespace App\Http\Controllers;

use Illuminate\Support\Facades\Route;
use \Illuminate\Http\Request;
use App\Http\Controllers\Source;
use App\Http\Controllers\Admin;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::post('/admin/loginAuth', [Admin::class, 'loginAuth']);
Route::get('/logout', [Admin::class, 'logout']);
Route::get('/', [Admin::class, 'index']);
Route::get('/upfiles',[Admin::class,'updatedFiles']);
Route::get('/moveFiles2Live',[Admin::class,'moveFiles2Live']);
Route::get('/removeFilesFromList',[Admin::class,'removeFilesFromList']);
Route::get('/dashboard', [Admin::class, 'dashboard']);
Route::get('/source/getFileList', [Source::class, 'getFileList']);
Route::get('/downloadFile/{path}',[Source::class,'downloadFile'])->where('path','.*');
Route::get('/source/file/{path}', [Source::class, 'editFile'])->where('path','.*');
Route::post('/source/saveFileContent', [Source::class, 'saveFileContent']);
Route::post('/source/createNew', [Source::class, 'createNew']);
Route::post('/source/renameFile', [Source::class, 'renameFile']);
Route::post('/source/deleteFile', [Source::class, 'deleteFile']);
Route::post('/source/copyFile', [Source::class, 'copyFile']);